// Commando Droid Droid WS2812B and Voice
//John Guarnero 2020

#include <Adafruit_NeoPixel.h>

//Define Arduino Pins to control NeoPixels / WS2812B LEDS
#define Pin_Mouth  3 //Pin 3 is the Mouth
#define Pin_Eyes   4 //Pin 4 is the Eyes
#define Pin_Chest  5 //Pin 5 is the Chest

// Number of NeoPixels / WS2812B LEDS attached to each pin
#define NumPixels_Mouth 1  //Neopixel Mini Button 1 Neopixel
#define NumPixels_Chest 1  //Neopixel Mini Button 1 Neopixel
#define NumPixels_Eyes 2   //Neopixel Mini Button 1 Neopixel

// When setting up the NeoPixel / WS2812B LEDS library, we tell it how many pixels,
// and which pin to use to send signals.
Adafruit_NeoPixel Mouth(NumPixels_Mouth, Pin_Mouth, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel Eyes(NumPixels_Eyes, Pin_Eyes, NEO_RGBW + NEO_KHZ800);
Adafruit_NeoPixel Chest(NumPixels_Chest, Pin_Chest, NEO_RGBW + NEO_KHZ800);

//Define Variables used in the program
int whitecolor = 50;  // White color intensiy (0-250 allowed)
int pin_val;
int BlinkRate;
int Chest_Pixels = 0;
int Chest_Fade_Up = 0;
int Chest_Fade_Down = 1;
unsigned long previousMillis = 0;       
unsigned long previousMillischest = 0;  


void setup() 

{

 Mouth.begin(); 
 Mouth.clear(); 
 Eyes.begin(); 
 Eyes.clear(); 
 Chest.begin(); 
 Chest.clear(); 

}

//Program runs code below - Void Loop
void loop()
{

//Eyes
   BlinkRate = random(6000, 12000);  // BlinkRate will randomly become active between 6 seconds and 12 seconds
  
  unsigned long currentMillis = millis();   //millis is used to avoid using a delay command in the code
 if (currentMillis - previousMillis > 50) {
   Eyes.setPixelColor(0, Eyes.Color(whitecolor, whitecolor, whitecolor, whitecolor));  
   Eyes.setPixelColor(1, Eyes.Color(whitecolor, whitecolor, whitecolor, whitecolor));    
   Eyes.show();  //Update the Eye NeoPixels
  } //IF statement end bracket

   if (currentMillis - previousMillis >= BlinkRate) { // Blink the Eyes off
    previousMillis = currentMillis;
   Eyes.setPixelColor(0, Eyes.Color(0, 0, 0, 0));   //Turn off Eye Leds
   Eyes.setPixelColor(1, Eyes.Color(0, 0, 0, 0));   //Turn off Eye Leds 
   Eyes.show();  //Update the Eye NeoPixels
  } //IF statement end bracket
  
//Chest 
   unsigned long currentMillischest = millis();

   if (currentMillischest - previousMillischest >50) {
    previousMillischest = currentMillischest;

//Chest LED is set to Red color that fades up and down
//Red Color Fade Up
 if (Chest_Fade_Up == 1) {
  Chest_Pixels = Chest_Pixels + 10;
  if (Chest_Pixels > 250) {
  Chest_Fade_Up = 0;
  Chest_Fade_Down = 1;
  } //IF statement end bracket
  } //IF statement end bracket
  
//Red Color Fade Down
if (Chest_Fade_Down == 1) {
  Chest_Pixels = Chest_Pixels - 10;
  if (Chest_Pixels < 20) {
  Chest_Fade_Up = 1;
  Chest_Fade_Down = 0;
  } //IF statement end bracket
  } //IF statement end bracket
  
   Chest.setPixelColor(0, Chest.Color(0,Chest_Pixels, 0, 0)); //The Chest just flashed random colors 
   Chest.show(); 
    } //IF statement end bracket
  

//Mouth - Set Neopixel intesity based on Sparkfun gate input
  pinMode(6, INPUT);
  pin_val = digitalRead(6);

 if (pin_val == 1) { //Mouth LED On
  Mouth.setPixelColor(0, 250,0,0); //The Mouth Green, Red, Blue, White 
  Mouth.show(); 
  } //IF statement end bracket

   if (pin_val == 0) { //Mouth LED Off
  Mouth.setPixelColor(0, 0,0,0); //The Mouth Green, Red, Blue, White 
  Mouth.show(); 
  } //IF statement end bracket
  
  } // End of Program Void Loop end bracket

 


  
  
  
  
  
 
